GNU bug report logs - #30385
Add vim-build-system

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: ng0@HIDDEN; Keywords: patch moreinfo; merged with #31989; dated Wed, 7 Feb 2018 22:34:02 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.
Merged 30385 31989. Request was from Ricardo Wurmus <ricardo.wurmus@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 30385 <at> debbugs.gnu.org:


Received: (at 30385) by debbugs.gnu.org; 26 Jun 2018 14:47:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 26 10:47:01 2018
Received: from localhost ([127.0.0.1]:36351 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fXpFA-0000kT-Py
	for submit <at> debbugs.gnu.org; Tue, 26 Jun 2018 10:47:00 -0400
Received: from static.195.114.201.195.clients.your-server.de
 ([195.201.114.195]:42918 helo=conspiracy.of.n0.is)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ng0@HIDDEN>) id 1fXpF7-0000kJ-TF
 for 30385 <at> debbugs.gnu.org; Tue, 26 Jun 2018 10:46:54 -0400
Received: by conspiracy.of.n0.is (OpenSMTPD) with ESMTPSA id f280fb0e
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256:NO); 
 Tue, 26 Jun 2018 14:46:51 +0000 (UTC)
Date: Tue, 26 Jun 2018 14:47:28 +0000
From: Nils Gillmann <ng0@HIDDEN>
To: Ricardo Wurmus <ricardo.wurmus@HIDDEN>
Subject: Re: [bug#30385] Add vim-build-system
Message-ID: <20180626144728.i6cwloiexh3rp4ey@abyayala>
References: <87a7wkv3eh.fsf@HIDDEN>
 <871sd0tgwb.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <871sd0tgwb.fsf@HIDDEN>
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 30385
Cc: 30385 <at> debbugs.gnu.org, ng0@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Ricardo Wurmus transcribed 11K bytes:
> 
> > This adds a first version of a functional vim-build-system.
> 
> Thank you.
> 
> Sorry for the delay.  I just went through this but found a couple of
> defects.
> 
> I fixed the regular expressions in %default-exclude, removed unused
> module imports, and fixed minor indentation problems, but then I noticed
> a few more fundamental problems.
> 
> * %default-exclude is not used.  The “install” phase unconditionally
>    installs everything
> 
> * The build system does not support an #:exclude argument that would
>   allow a user to override the behaviour.  (Compare this to the
>   ant-build-system, which supports excluding tests, for example.)
> 
> * The build system allows users to specify a test-target and disable
>   tests (they default to #t), but there is no check phase anyway.  It
>   also supports configure-flags, but it would not use them.
> 
> Attached is the patch with my minor changes.
> 
> Could you please send an updated patch where these problems are
> addressed?
> 
> Thanks!

Hi,

thanks again for your review. I'm currently busy, I had no time to
work on an update. I will send one soon enough.

This is just as a notice that I'll do it, there's just other tasks
keeping me occupied.

> --
> Ricardo
> 

> From 7decc6cd27af54994abfc396beaeae68a6acd69a Mon Sep 17 00:00:00 2001
> From: ng0 <ng0@HIDDEN>
> Date: Sun, 2 Jul 2017 16:07:48 +0000
> Subject: [PATCH] build-system: Add vim-build-system.
> 
> * Makefile.am (MODULES): Add guix/build-system/vim.scm and
> guix/build/vim-build-system.scm.
> * guix/build-system/vim.scm: New file.
> * guix/build/vim-build-system.scm: New file.
> 
> Signed-off-by: Ricardo Wurmus <rekado@HIDDEN>
> ---
>  Makefile.am                     |   2 +
>  guix/build-system/vim.scm       | 129 ++++++++++++++++++++++++++++++++
>  guix/build/vim-build-system.scm |  91 ++++++++++++++++++++++
>  3 files changed, 222 insertions(+)
>  create mode 100644 guix/build-system/vim.scm
>  create mode 100644 guix/build/vim-build-system.scm
> 
> diff --git a/Makefile.am b/Makefile.am
> index ab145065d..b5d910139 100644
> --- a/Makefile.am
> +++ b/Makefile.am
> @@ -114,6 +114,7 @@ MODULES =					\
>    guix/build-system/perl.scm			\
>    guix/build-system/python.scm			\
>    guix/build-system/ocaml.scm			\
> +  guix/build-system/vim.scm			\
>    guix/build-system/waf.scm			\
>    guix/build-system/r.scm			\
>    guix/build-system/ruby.scm			\
> @@ -143,6 +144,7 @@ MODULES =					\
>    guix/build/font-build-system.scm		\
>    guix/build/go-build-system.scm		\
>    guix/build/asdf-build-system.scm		\
> +  guix/build/vim-build-system.scm		\
>    guix/build/git.scm				\
>    guix/build/hg.scm				\
>    guix/build/glib-or-gtk-build-system.scm	\
> diff --git a/guix/build-system/vim.scm b/guix/build-system/vim.scm
> new file mode 100644
> index 000000000..9bd44e077
> --- /dev/null
> +++ b/guix/build-system/vim.scm
> @@ -0,0 +1,129 @@
> +;;; GNU Guix --- Functional package management for GNU
> +;;; Copyright © 2018 ng0 <ng0@HIDDEN>
> +;;;
> +;;; This file is part of GNU Guix.
> +;;;
> +;;; GNU Guix is free software; you can redistribute it and/or modify it
> +;;; under the terms of the GNU General Public License as published by
> +;;; the Free Software Foundation; either version 3 of the License, or (at
> +;;; your option) any later version.
> +;;;
> +;;; GNU Guix is distributed in the hope that it will be useful, but
> +;;; WITHOUT ANY WARRANTY; without even the implied warranty of
> +;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +;;; GNU General Public License for more details.
> +;;;
> +;;; You should have received a copy of the GNU General Public License
> +;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
> +
> +(define-module (guix build-system vim)
> +  #:use-module (guix utils)
> +  #:use-module (guix packages)
> +  #:use-module (guix derivations)
> +  #:use-module (guix store)
> +  #:use-module (guix search-paths)
> +  #:use-module (guix build-system)
> +  #:use-module (guix build-system gnu)
> +  #:use-module (ice-9 match)
> +  #:export (%vim-build-system-modules
> +            vim-build
> +            vim-build-system))
> +
> +;; Commentary:
> +;;
> +;; Standard build procedure for vim packages.  This is
> +;; implemented as an extension of 'gnu-build-system'.
> +;;
> +;; Code:
> +
> +(define %vim-build-system-modules
> +  ;; Build-side modules imported by default.
> +  `((guix build vim-build-system)
> +    ,@%gnu-build-system-modules))
> +
> +(define* (lower name
> +                #:key source inputs native-inputs outputs system target
> +                #:allow-other-keys
> +                #:rest arguments)
> +  "Return a bag for NAME."
> +  (define private-keywords
> +    '(#:target #:inputs #:exclude #:native-inputs))
> +
> +  (bag
> +    (name name)
> +    (system system)
> +    (host-inputs `(,@(if source
> +                         `(("source" ,source))
> +                         '())
> +                   ,@inputs
> +                   ,(list "tar" (module-ref (resolve-interface '(gnu packages base)) 'tar))
> +                   ,@(let ((compression (resolve-interface '(gnu packages compression))))
> +                       (map (match-lambda
> +                              ((name package)
> +                               (list name (module-ref compression package))))
> +                            `(("gzip" gzip)
> +                              ("bzip2" bzip2)
> +                              ("unzip" unzip)
> +                              ("xz" xz))))))
> +    (build-inputs native-inputs)
> +    (outputs outputs)
> +    (build vim-build)
> +    (arguments (strip-keyword-arguments private-keywords arguments))))
> +
> +(define* (vim-build store name inputs
> +                     #:key source
> +                     (tests? #t)
> +                     (test-target "test")
> +                     (configure-flags ''())
> +                     (phases '(@ (guix build vim-build-system)
> +                                 %standard-phases))
> +                     (outputs '("out"))
> +                     (search-paths '())
> +                     (system (%current-system))
> +                     (guile #f)
> +                     (imported-modules %vim-build-system-modules)
> +                     (modules '((guix build vim-build-system)
> +                                (guix build utils))))
> +  "Build SOURCE with INPUTS."
> +  (define builder
> +    `(begin
> +       (use-modules ,@modules)
> +       (vim-build #:name ,name
> +                   #:source ,(match (assoc-ref inputs "source")
> +                               (((? derivation? source))
> +                                (derivation->output-path source))
> +                               ((source)
> +                                source)
> +                               (source
> +                                source))
> +                   #:configure-flags ,configure-flags
> +                   #:system ,system
> +                   #:test-target ,test-target
> +                   #:tests? ,tests?
> +                   #:phases ,phases
> +                   #:outputs %outputs
> +                   #:search-paths ',(map search-path-specification->sexp
> +                                         search-paths)
> +                   #:inputs %build-inputs)))
> +
> +  (define guile-for-build
> +    (match guile
> +      ((? package?)
> +       (package-derivation store guile system #:graft? #f))
> +      (#f                                         ; the default
> +       (let* ((distro (resolve-interface '(gnu packages commencement)))
> +              (guile  (module-ref distro 'guile-final)))
> +         (package-derivation store guile system #:graft? #f)))))
> +
> +  (build-expression->derivation store name builder
> +                                #:inputs inputs
> +                                #:system system
> +                                #:modules imported-modules
> +                                #:outputs outputs
> +                                #:guile-for-build guile-for-build))
> +
> +(define vim-build-system
> +  (build-system
> +    (name 'vim)
> +    (description "The build system for vim packages")
> +    (lower lower)))
> diff --git a/guix/build/vim-build-system.scm b/guix/build/vim-build-system.scm
> new file mode 100644
> index 000000000..a8a6221e9
> --- /dev/null
> +++ b/guix/build/vim-build-system.scm
> @@ -0,0 +1,91 @@
> +;;; GNU Guix --- Functional package management for GNU
> +;;; Copyright © 2018 ng0 <ng0@HIDDEN>
> +;;;
> +;;; This file is part of GNU Guix.
> +;;;
> +;;; GNU Guix is free software; you can redistribute it and/or modify it
> +;;; under the terms of the GNU General Public License as published by
> +;;; the Free Software Foundation; either version 3 of the License, or (at
> +;;; your option) any later version.
> +;;;
> +;;; GNU Guix is distributed in the hope that it will be useful, but
> +;;; WITHOUT ANY WARRANTY; without even the implied warranty of
> +;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +;;; GNU General Public License for more details.
> +;;;
> +;;; You should have received a copy of the GNU General Public License
> +;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
> +
> +(define-module (guix build vim-build-system)
> +  #:use-module ((guix build gnu-build-system) #:prefix gnu:)
> +  #:use-module (guix build utils)
> +  #:use-module (srfi srfi-11)
> +  #:export (%standard-phases
> +            %default-exclude
> +            vim-build))
> +
> +;; Commentary:
> +;;
> +;; Builder-side code of the build procedure for vim packages.
> +;;
> +;; Code:
> +
> +;; These are the default inclusion/exclusion regexps for the install phase.
> +(define %default-exclude '("^.github$" "^.*\\.md$" "LICENSE" "COPYING"
> +                           "^.*README.*$" "^\\.travis\\.yml$"
> +                           "^.*Makefile.*$"))
> +
> +(define gnu:unpack (assoc-ref gnu:%standard-phases 'unpack))
> +
> +(define (store-file->vim-source-file file)
> +  "Convert FILE, a store file name for an Vim source file, into a file
> +name that has been stripped of the hash and version number."
> +  (let ((suffix ".vim"))
> +    (let-values (((name version)
> +                  (package-name->name+version
> +                   (basename
> +                    (strip-store-file-name file) suffix))))
> +      (string-append name suffix))))
> +
> +(define* (unpack #:key source #:allow-other-keys)
> +  "Unpack SOURCE into the build directory.  SOURCE may be a compressed
> +archive, a directory or a '.vim' file."
> +  (if (string-suffix? ".vim" source)
> +      (begin
> +        (mkdir "source")
> +        (chdir "source")
> +        (copy-file source (store-file->vim-source-file source))
> +        #t)
> +      (gnu:unpack #:source source)))
> +
> +;; FIXME: Files like README.md and other, more unpredictable file names,
> +;; are currently being installed. Because there is no concept of a
> +;; standardized build-system in Vim extensions, we have to find a long-term
> +;; solution to exclusion of files that are not used at runtime.
> +(define* (install #:key outputs
> +                  (exclude %default-exclude)
> +                  #:allow-other-keys)
> +  "Install the package contents."
> +  (let* ((out (assoc-ref outputs "out"))
> +         (source (getcwd))
> +         (vimfiles (string-append out "/share/vim/vimfiles")))
> +    (for-each delete-file-recursively
> +              (find-files source "^\\.git$"))
> +    (for-each delete-file-recursively
> +              (find-files source "^\\.gitignore$"))
> +    (mkdir out)
> +    (copy-recursively "." vimfiles)
> +    #t))
> +
> +(define %standard-phases
> +  (modify-phases gnu:%standard-phases
> +    (replace 'unpack unpack)
> +    (delete 'configure)
> +    (delete 'check)
> +    (delete 'build)
> +    (replace 'install install)))
> +
> +(define* (vim-build #:key inputs (phases %standard-phases)
> +                    #:allow-other-keys #:rest args)
> +  "Build the given vim package, applying all of PHASES in order."
> +  (apply gnu:gnu-build #:inputs inputs #:phases phases args))
> -- 
> 2.17.1
> 





Information forwarded to guix-patches@HIDDEN:
bug#30385; Package guix-patches. Full text available.
Added tag(s) moreinfo. Request was from Ricardo Wurmus <ricardo.wurmus@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 30385 <at> debbugs.gnu.org:


Received: (at 30385) by debbugs.gnu.org; 21 Jun 2018 13:21:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 21 09:21:20 2018
Received: from localhost ([127.0.0.1]:58366 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fVzWV-00022I-Vn
	for submit <at> debbugs.gnu.org; Thu, 21 Jun 2018 09:21:20 -0400
Received: from sinope02.bbbm.mdc-berlin.de ([141.80.25.24]:59038)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <Ricardo.Wurmus@HIDDEN>) id 1fVzWQ-000227-6M
 for 30385 <at> debbugs.gnu.org; Thu, 21 Jun 2018 09:21:11 -0400
Received: from localhost (localhost [127.0.0.1])
 by sinope02.bbbm.mdc-berlin.de (Postfix) with ESMTP id 4820911A16E6;
 Thu, 21 Jun 2018 15:21:09 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=mdc-berlin.de; h=
 content-type:content-type:mime-version:message-id:date:date
 :in-reply-to:subject:subject:from:from:user-agent:references
 :received:received:received:received; s=mdc; t=1529587263; x=
 1531401664; bh=mUhAq0z/utpYUaw5ptcuVmDXoo+rtp/vfqwV9NWI2W0=; b=Q
 3c+jJFqxpx0S35gxl/O4Wv40vjnn//Pz3pefGYOja/07KhtHS3L5SSqYnwT7TEH9
 KFvXQUiNxgj9I1tKP+shiDIjA4AyAvx4UrwYgz0d5IWhlN/lkIbnuouHgFJKN2lF
 af3LUBqJNhy/sznVd8koTvMTMO9EQWfF1OnBYME0s4=
X-Virus-Scanned: amavisd-new at mdc-berlin.de
Received: from sinope02.bbbm.mdc-berlin.de ([127.0.0.1])
 by localhost (sinope02.bbbm.mdc-berlin.de [127.0.0.1]) (amavisd-new,
 port 10024)
 with ESMTP id DqYWzYICIFce; Thu, 21 Jun 2018 15:21:03 +0200 (CEST)
Received: from HTCATWO.mdc-berlin.net (puck.citx.mdc-berlin.de [141.80.36.101])
 (using TLSv1 with cipher ECDHE-RSA-AES256-SHA (256/256 bits))
 (No client certificate requested)
 by sinope02.bbbm.mdc-berlin.de (Postfix) with ESMTPS;
 Thu, 21 Jun 2018 15:21:03 +0200 (CEST)
Received: from SW-IT-P-CAS4.mdc-berlin.net (141.80.113.59) by
 HTCATWO.mdc-berlin.net (141.80.180.190) with Microsoft SMTP Server (TLS) id
 14.3.399.0; Thu, 21 Jun 2018 15:21:03 +0200
Received: from localhost (141.80.113.51) by SW-IT-P-CAS4.mdc-berlin.net
 (141.80.113.59) with Microsoft SMTP Server id 14.3.399.0; Thu, 21 Jun 2018
 15:21:02 +0200
References: <87a7wkv3eh.fsf@HIDDEN>
User-agent: mu4e 1.0; emacs 26.1
From: Ricardo Wurmus <ricardo.wurmus@HIDDEN>
To: <ng0@HIDDEN>
Subject: Re: [bug#30385] Add vim-build-system
In-Reply-To: <87a7wkv3eh.fsf@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Thu, 21 Jun 2018 15:20:52 +0200
Message-ID: <871sd0tgwb.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Originating-IP: [141.80.113.51]
X-TM-AS-Product-Ver: SMEX-12.5.0.1300-8.2.1013-23920.006
X-TM-AS-Result: No-13.231200-8.000000-10
X-TMASE-MatchedRID: zGP2F0O7j/vo2d3orePV3fHkpkyUphL9Za7LkubQvj9jPrlNB+gMq1e/
 KWmAuveArc2kEsHh4aZl2Szw4gtLAeBX8Ypq0C8lSk3ASAlP761ezmeoa8MJ80uCjz4ggdtwoQE
 YbyRPJnd53DrnZ9A6ExEIoddjVdcsIly/lfs5uYn9vE/QVDV5IRNtTUpgahCn+Cckfm+bb6DOXi
 w/vAtmtSPKmcaFmhj14gap5MvM7lCsP7gN7d9IwTWnQyoYXNHZVkJ4hxc37K9fNjF5BHUO+80X3
 rZe95Q5TQ0j/deBrVPCQOCHizeBUgOPIDYCx7que0f0oZqxJUk=
X-TM-AS-User-Approved-Sender: Yes
X-TM-AS-User-Blocked-Sender: No
X-TMASE-Result: 10--13.231200-8.000000
X-TMASE-Version: SMEX-12.5.0.1300-8.2.1013-23920.006
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 30385
Cc: 30385 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable


> This adds a first version of a functional vim-build-system.

Thank you.

Sorry for the delay.  I just went through this but found a couple of
defects.

I fixed the regular expressions in %default-exclude, removed unused
module imports, and fixed minor indentation problems, but then I noticed
a few more fundamental problems.

* %default-exclude is not used.  The =E2=80=9Cinstall=E2=80=9D phase uncond=
itionally
   installs everything

* The build system does not support an #:exclude argument that would
  allow a user to override the behaviour.  (Compare this to the
  ant-build-system, which supports excluding tests, for example.)

* The build system allows users to specify a test-target and disable
  tests (they default to #t), but there is no check phase anyway.  It
  also supports configure-flags, but it would not use them.

Attached is the patch with my minor changes.

Could you please send an updated patch where these problems are
addressed?

Thanks!

--
Ricardo


--=-=-=
Content-Type: text/x-patch; charset="utf-8"
Content-Disposition: inline;
	filename="0001-build-system-Add-vim-build-system.patch"
Content-Transfer-Encoding: quoted-printable

From 7decc6cd27af54994abfc396beaeae68a6acd69a Mon Sep 17 00:00:00 2001
From: ng0 <ng0@HIDDEN>
Date: Sun, 2 Jul 2017 16:07:48 +0000
Subject: [PATCH] build-system: Add vim-build-system.

* Makefile.am (MODULES): Add guix/build-system/vim.scm and
guix/build/vim-build-system.scm.
* guix/build-system/vim.scm: New file.
* guix/build/vim-build-system.scm: New file.

Signed-off-by: Ricardo Wurmus <rekado@HIDDEN>
---
 Makefile.am                     |   2 +
 guix/build-system/vim.scm       | 129 ++++++++++++++++++++++++++++++++
 guix/build/vim-build-system.scm |  91 ++++++++++++++++++++++
 3 files changed, 222 insertions(+)
 create mode 100644 guix/build-system/vim.scm
 create mode 100644 guix/build/vim-build-system.scm

diff --git a/Makefile.am b/Makefile.am
index ab145065d..b5d910139 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -114,6 +114,7 @@ MODULES =3D					\
   guix/build-system/perl.scm			\
   guix/build-system/python.scm			\
   guix/build-system/ocaml.scm			\
+  guix/build-system/vim.scm			\
   guix/build-system/waf.scm			\
   guix/build-system/r.scm			\
   guix/build-system/ruby.scm			\
@@ -143,6 +144,7 @@ MODULES =3D					\
   guix/build/font-build-system.scm		\
   guix/build/go-build-system.scm		\
   guix/build/asdf-build-system.scm		\
+  guix/build/vim-build-system.scm		\
   guix/build/git.scm				\
   guix/build/hg.scm				\
   guix/build/glib-or-gtk-build-system.scm	\
diff --git a/guix/build-system/vim.scm b/guix/build-system/vim.scm
new file mode 100644
index 000000000..9bd44e077
--- /dev/null
+++ b/guix/build-system/vim.scm
@@ -0,0 +1,129 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix build-system vim)
+  #:use-module (guix utils)
+  #:use-module (guix packages)
+  #:use-module (guix derivations)
+  #:use-module (guix store)
+  #:use-module (guix search-paths)
+  #:use-module (guix build-system)
+  #:use-module (guix build-system gnu)
+  #:use-module (ice-9 match)
+  #:export (%vim-build-system-modules
+            vim-build
+            vim-build-system))
+
+;; Commentary:
+;;
+;; Standard build procedure for vim packages.  This is
+;; implemented as an extension of 'gnu-build-system'.
+;;
+;; Code:
+
+(define %vim-build-system-modules
+  ;; Build-side modules imported by default.
+  `((guix build vim-build-system)
+    ,@%gnu-build-system-modules))
+
+(define* (lower name
+                #:key source inputs native-inputs outputs system target
+                #:allow-other-keys
+                #:rest arguments)
+  "Return a bag for NAME."
+  (define private-keywords
+    '(#:target #:inputs #:exclude #:native-inputs))
+
+  (bag
+    (name name)
+    (system system)
+    (host-inputs `(,@(if source
+                         `(("source" ,source))
+                         '())
+                   ,@inputs
+                   ,(list "tar" (module-ref (resolve-interface '(gnu packa=
ges base)) 'tar))
+                   ,@(let ((compression (resolve-interface '(gnu packages =
compression))))
+                       (map (match-lambda
+                              ((name package)
+                               (list name (module-ref compression package)=
)))
+                            `(("gzip" gzip)
+                              ("bzip2" bzip2)
+                              ("unzip" unzip)
+                              ("xz" xz))))))
+    (build-inputs native-inputs)
+    (outputs outputs)
+    (build vim-build)
+    (arguments (strip-keyword-arguments private-keywords arguments))))
+
+(define* (vim-build store name inputs
+                     #:key source
+                     (tests? #t)
+                     (test-target "test")
+                     (configure-flags ''())
+                     (phases '(@ (guix build vim-build-system)
+                                 %standard-phases))
+                     (outputs '("out"))
+                     (search-paths '())
+                     (system (%current-system))
+                     (guile #f)
+                     (imported-modules %vim-build-system-modules)
+                     (modules '((guix build vim-build-system)
+                                (guix build utils))))
+  "Build SOURCE with INPUTS."
+  (define builder
+    `(begin
+       (use-modules ,@modules)
+       (vim-build #:name ,name
+                   #:source ,(match (assoc-ref inputs "source")
+                               (((? derivation? source))
+                                (derivation->output-path source))
+                               ((source)
+                                source)
+                               (source
+                                source))
+                   #:configure-flags ,configure-flags
+                   #:system ,system
+                   #:test-target ,test-target
+                   #:tests? ,tests?
+                   #:phases ,phases
+                   #:outputs %outputs
+                   #:search-paths ',(map search-path-specification->sexp
+                                         search-paths)
+                   #:inputs %build-inputs)))
+
+  (define guile-for-build
+    (match guile
+      ((? package?)
+       (package-derivation store guile system #:graft? #f))
+      (#f                                         ; the default
+       (let* ((distro (resolve-interface '(gnu packages commencement)))
+              (guile  (module-ref distro 'guile-final)))
+         (package-derivation store guile system #:graft? #f)))))
+
+  (build-expression->derivation store name builder
+                                #:inputs inputs
+                                #:system system
+                                #:modules imported-modules
+                                #:outputs outputs
+                                #:guile-for-build guile-for-build))
+
+(define vim-build-system
+  (build-system
+    (name 'vim)
+    (description "The build system for vim packages")
+    (lower lower)))
diff --git a/guix/build/vim-build-system.scm b/guix/build/vim-build-system.=
scm
new file mode 100644
index 000000000..a8a6221e9
--- /dev/null
+++ b/guix/build/vim-build-system.scm
@@ -0,0 +1,91 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix build vim-build-system)
+  #:use-module ((guix build gnu-build-system) #:prefix gnu:)
+  #:use-module (guix build utils)
+  #:use-module (srfi srfi-11)
+  #:export (%standard-phases
+            %default-exclude
+            vim-build))
+
+;; Commentary:
+;;
+;; Builder-side code of the build procedure for vim packages.
+;;
+;; Code:
+
+;; These are the default inclusion/exclusion regexps for the install phase.
+(define %default-exclude '("^.github$" "^.*\\.md$" "LICENSE" "COPYING"
+                           "^.*README.*$" "^\\.travis\\.yml$"
+                           "^.*Makefile.*$"))
+
+(define gnu:unpack (assoc-ref gnu:%standard-phases 'unpack))
+
+(define (store-file->vim-source-file file)
+  "Convert FILE, a store file name for an Vim source file, into a file
+name that has been stripped of the hash and version number."
+  (let ((suffix ".vim"))
+    (let-values (((name version)
+                  (package-name->name+version
+                   (basename
+                    (strip-store-file-name file) suffix))))
+      (string-append name suffix))))
+
+(define* (unpack #:key source #:allow-other-keys)
+  "Unpack SOURCE into the build directory.  SOURCE may be a compressed
+archive, a directory or a '.vim' file."
+  (if (string-suffix? ".vim" source)
+      (begin
+        (mkdir "source")
+        (chdir "source")
+        (copy-file source (store-file->vim-source-file source))
+        #t)
+      (gnu:unpack #:source source)))
+
+;; FIXME: Files like README.md and other, more unpredictable file names,
+;; are currently being installed. Because there is no concept of a
+;; standardized build-system in Vim extensions, we have to find a long-term
+;; solution to exclusion of files that are not used at runtime.
+(define* (install #:key outputs
+                  (exclude %default-exclude)
+                  #:allow-other-keys)
+  "Install the package contents."
+  (let* ((out (assoc-ref outputs "out"))
+         (source (getcwd))
+         (vimfiles (string-append out "/share/vim/vimfiles")))
+    (for-each delete-file-recursively
+              (find-files source "^\\.git$"))
+    (for-each delete-file-recursively
+              (find-files source "^\\.gitignore$"))
+    (mkdir out)
+    (copy-recursively "." vimfiles)
+    #t))
+
+(define %standard-phases
+  (modify-phases gnu:%standard-phases
+    (replace 'unpack unpack)
+    (delete 'configure)
+    (delete 'check)
+    (delete 'build)
+    (replace 'install install)))
+
+(define* (vim-build #:key inputs (phases %standard-phases)
+                    #:allow-other-keys #:rest args)
+  "Build the given vim package, applying all of PHASES in order."
+  (apply gnu:gnu-build #:inputs inputs #:phases phases args))
--=20
2.17.1


--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#30385; Package guix-patches. Full text available.
Added tag(s) patch. Request was from Christopher Baines <mail@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 30385 <at> debbugs.gnu.org:


Received: (at 30385) by debbugs.gnu.org; 28 Feb 2018 22:08:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 28 17:08:51 2018
Received: from localhost ([127.0.0.1]:37990 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1er9u7-0007qk-7Q
	for submit <at> debbugs.gnu.org; Wed, 28 Feb 2018 17:08:51 -0500
Received: from hera.aquilenet.fr ([185.233.100.1]:33120)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1er9u5-0007qd-Py
 for 30385 <at> debbugs.gnu.org; Wed, 28 Feb 2018 17:08:50 -0500
Received: from localhost (localhost [127.0.0.1])
 by hera.aquilenet.fr (Postfix) with ESMTP id 62D7A10C6B;
 Wed, 28 Feb 2018 23:08:49 +0100 (CET)
X-Virus-Scanned: Debian amavisd-new at aquilenet.fr
Received: from hera.aquilenet.fr ([127.0.0.1])
 by localhost (hera.aquilenet.fr [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id Ijjf0dhuu-7o; Wed, 28 Feb 2018 23:08:48 +0100 (CET)
Received: from ribbon (unknown [IPv6:2a01:e0a:1d:7270:af76:b9b:ca24:c465])
 by hera.aquilenet.fr (Postfix) with ESMTPSA id 84F18DB1C;
 Wed, 28 Feb 2018 23:08:48 +0100 (CET)
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: ng0 <ng0@HIDDEN>
Subject: Re: [bug#30385] Add vim-build-system
References: <87a7wkv3eh.fsf@HIDDEN>
 <20180228085417.b2o725dxstovrwic@abyayala>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 10 =?utf-8?Q?Vent=C3=B4se?= an 226 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Wed, 28 Feb 2018 23:08:48 +0100
In-Reply-To: <20180228085417.b2o725dxstovrwic@abyayala> (ng0@HIDDEN's message
 of "Wed, 28 Feb 2018 08:54:17 +0000")
Message-ID: <87tvu0u5qn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/25.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 30385
Cc: 30385 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Hello ng0,

ng0 <ng0@HIDDEN> skribis:

> Are 4 patches too much?

As you can see on <https://bugs.gnu.org/guix-patches>, this is not the
only patch waiting for review.

All I can suggest is being patient, I=E2=80=99m sure everyone is doing their
best.  :-)

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#30385; Package guix-patches. Full text available.

Message received at 30385 <at> debbugs.gnu.org:


Received: (at 30385) by debbugs.gnu.org; 28 Feb 2018 08:54:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 28 03:54:44 2018
Received: from localhost ([127.0.0.1]:36432 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eqxVW-00068G-4s
	for submit <at> debbugs.gnu.org; Wed, 28 Feb 2018 03:54:44 -0500
Received: from aibo.runbox.com ([91.220.196.211]:52526)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ng0@HIDDEN>) id 1eqxVP-00067y-9O
 for 30385 <at> debbugs.gnu.org; Wed, 28 Feb 2018 03:54:36 -0500
Received: from [10.9.9.212] (helo=mailfront12.runbox.com)
 by mailtransmit02.runbox with esmtp (Exim 4.86_2)
 (envelope-from <ng0@HIDDEN>) id 1eqxVO-0003h8-48
 for 30385 <at> debbugs.gnu.org; Wed, 28 Feb 2018 09:54:30 +0100
Received: from dslb-094-220-189-159.094.220.pools.vodafone-ip.de
 ([94.220.189.159] helo=localhost)
 by mailfront12.runbox.com with esmtpsa (uid:892961 )
 (TLS1.2:RSA_AES_256_CBC_SHA1:256) (Exim 4.82) id 1eqxV1-0001na-3l
 for 30385 <at> debbugs.gnu.org; Wed, 28 Feb 2018 09:54:07 +0100
Date: Wed, 28 Feb 2018 08:54:17 +0000
From: ng0 <ng0@HIDDEN>
To: 30385 <at> debbugs.gnu.org
Subject: Re: [bug#30385] Add vim-build-system
Message-ID: <20180228085417.b2o725dxstovrwic@abyayala>
References: <87a7wkv3eh.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; micalg=pgp-sha512;
 protocol="application/pgp-signature"; boundary="bby7qmk6raz3dxfv"
Content-Disposition: inline
In-Reply-To: <87a7wkv3eh.fsf@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 30385
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.0 (/)


--bby7qmk6raz3dxfv
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

ng0@HIDDEN transcribed 19K bytes:
> This adds a first version of a functional vim-build-system.
>=20
> As explained today on IRC, and as you can guess by reading
> gnu/packages/vim.scm Vim has a concept of folders and files in
> standard places, but Makefiles and similar tools are an
> exception. Usually you have to copy them somewhere (or use
> external Vim package managers that pull the files for yoz and set
> the "run time path" (rtp) for you).
>=20
> There's also (to my best knowledge, keep in mind I've last read
> into Vim when I did the last commits in the Vim module) no ENV
> VAR or anything we could export, you have to manually set
>=20
>   set rtp+=3D~/.guix-profile/share/vim/vimfiles/
>=20
> in your $home/.vimrc
>=20
> The build system comes with a FIXME note, but it works. I'm in
> the middle of tests and exams, so this is the best I can correct
> from my earlier attempt in '17 on this. What I can apply are
> changes and adjustments to what I submit now.
>=20
> 4 Patches attached, 3 of them are for proof of work.
>=20

Are 4 patches too much? Do we have no vim users here?
I've never written a build system for Guix before, so
if anyone feels like doing the QA here that would be
nice.

> From 617fc10671c18c35c0e3fcd6bc0c9d06a96a4ebf Mon Sep 17 00:00:00 2001
> From: ng0 <ng0@HIDDEN>
> Date: Sun, 2 Jul 2017 16:07:48 +0000
> Subject: [PATCH 1/4] build-system: Add 'vim-build-system'.
>=20
> * Makefile.am (MODULES): Add 'guix/build-system/vim.scm' and
> 'guix/build/vim-build-system.scm'.
> * guix/build-system/vim.scm: New file.
> * guix/build/vim-build-system.scm: New file.
> ---
>  Makefile.am                     |   4 +-
>  guix/build-system/vim.scm       | 129 ++++++++++++++++++++++++++++++++++=
++++++
>  guix/build/vim-build-system.scm |  93 +++++++++++++++++++++++++++++
>  3 files changed, 225 insertions(+), 1 deletion(-)
>  create mode 100644 guix/build-system/vim.scm
>  create mode 100644 guix/build/vim-build-system.scm
>=20
> diff --git a/Makefile.am b/Makefile.am
> index eb5d38231..72ad184ef 100644
> --- a/Makefile.am
> +++ b/Makefile.am
> @@ -9,7 +9,7 @@
>  # Copyright =C2=A9 2017 Ricardo Wurmus <rekado@HIDDEN>
>  # Copyright =C2=A9 2017 Jan Nieuwenhuizen <janneke@HIDDEN>
>  # Copyright =C2=A9 2017 Arun Isaac <arunisaac@HIDDEN>
> -# Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
> +# Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
>  #
>  # This file is part of GNU Guix.
>  #
> @@ -106,6 +106,7 @@ MODULES =3D					\
>    guix/build-system/perl.scm			\
>    guix/build-system/python.scm			\
>    guix/build-system/ocaml.scm			\
> +  guix/build-system/vim.scm                     \
>    guix/build-system/waf.scm			\
>    guix/build-system/r.scm			\
>    guix/build-system/ruby.scm			\
> @@ -134,6 +135,7 @@ MODULES =3D					\
>    guix/build/font-build-system.scm		\
>    guix/build/go-build-system.scm		\
>    guix/build/asdf-build-system.scm		\
> +  guix/build/vim-build-system.scm               \
>    guix/build/git.scm				\
>    guix/build/hg.scm				\
>    guix/build/glib-or-gtk-build-system.scm	\
> diff --git a/guix/build-system/vim.scm b/guix/build-system/vim.scm
> new file mode 100644
> index 000000000..67657c7d8
> --- /dev/null
> +++ b/guix/build-system/vim.scm
> @@ -0,0 +1,129 @@
> +;;; GNU Guix --- Functional package management for GNU
> +;;; Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
> +;;;
> +;;; This file is part of GNU Guix.
> +;;;
> +;;; GNU Guix is free software; you can redistribute it and/or modify it
> +;;; under the terms of the GNU General Public License as published by
> +;;; the Free Software Foundation; either version 3 of the License, or (at
> +;;; your option) any later version.
> +;;;
> +;;; GNU Guix is distributed in the hope that it will be useful, but
> +;;; WITHOUT ANY WARRANTY; without even the implied warranty of
> +;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +;;; GNU General Public License for more details.
> +;;;
> +;;; You should have received a copy of the GNU General Public License
> +;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
> +
> +(define-module (guix build-system vim)
> +  #:use-module (guix utils)
> +  #:use-module (guix packages)
> +  #:use-module (guix derivations)
> +  #:use-module (guix store)
> +  #:use-module (guix search-paths)
> +  #:use-module (guix build-system)
> +  #:use-module (guix build-system gnu)
> +  #:use-module (ice-9 match)
> +  #:export (%vim-build-system-modules
> +            vim-build
> +            vim-build-system))
> +
> +;; Commentary:
> +;;
> +;; Standard build procedure for vim packages.  This is
> +;; implemented as an extension of 'gnu-build-system'.
> +;;
> +;; Code:
> +
> +(define %vim-build-system-modules
> +  ;; Build-side modules imported by default.
> +  `((guix build vim-build-system)
> +    ,@%gnu-build-system-modules))
> +
> +(define* (lower name
> +                #:key source inputs native-inputs outputs system target
> +                #:allow-other-keys
> +                #:rest arguments)
> +  "Return a bag for NAME."
> +  (define private-keywords
> +    '(#:target #:inputs #:native-inputs))
> +
> +  (bag
> +    (name name)
> +    (system system)
> +    (host-inputs `(,@(if source
> +                         `(("source" ,source))
> +                         '())
> +                   ,@inputs
> +                   ,(list "tar" (module-ref (resolve-interface '(gnu pac=
kages base)) 'tar))
> +                   ,@(let ((compression (resolve-interface '(gnu package=
s compression))))
> +                       (map (match-lambda
> +                              ((name package)
> +                               (list name (module-ref compression packag=
e))))
> +                            `(("gzip" gzip)
> +                              ("bzip2" bzip2)
> +                              ("unzip" unzip)
> +                              ("xz" xz))))))
> +    (build-inputs native-inputs)
> +    (outputs outputs)
> +    (build vim-build)
> +    (arguments (strip-keyword-arguments private-keywords arguments))))
> +
> +(define* (vim-build store name inputs
> +                     #:key source
> +                     (tests? #t)
> +                     (test-target "test")
> +                     (configure-flags ''())
> +                     (phases '(@ (guix build vim-build-system)
> +                                 %standard-phases))
> +                     (outputs '("out"))
> +                     (search-paths '())
> +                     (system (%current-system))
> +                     (guile #f)
> +                     (imported-modules %vim-build-system-modules)
> +                     (modules '((guix build vim-build-system)
> +                                (guix build utils))))
> +  "Build SOURCE with INPUTS."
> +  (define builder
> +    `(begin
> +       (use-modules ,@modules)
> +       (vim-build #:name ,name
> +                   #:source ,(match (assoc-ref inputs "source")
> +                               (((? derivation? source))
> +                                (derivation->output-path source))
> +                               ((source)
> +                                source)
> +                               (source
> +                                source))
> +                   #:configure-flags ,configure-flags
> +                   #:system ,system
> +                   #:test-target ,test-target
> +                   #:tests? ,tests?
> +                   #:phases ,phases
> +                   #:outputs %outputs
> +                   #:search-paths ',(map search-path-specification->sexp
> +                                         search-paths)
> +                   #:inputs %build-inputs)))
> +
> +  (define guile-for-build
> +    (match guile
> +      ((? package?)
> +       (package-derivation store guile system #:graft? #f))
> +      (#f                                         ; the default
> +       (let* ((distro (resolve-interface '(gnu packages commencement)))
> +              (guile  (module-ref distro 'guile-final)))
> +         (package-derivation store guile system #:graft? #f)))))
> +
> +  (build-expression->derivation store name builder
> +                                #:inputs inputs
> +                                #:system system
> +                                #:modules imported-modules
> +                                #:outputs outputs
> +                                #:guile-for-build guile-for-build))
> +
> +(define vim-build-system
> +  (build-system
> +    (name 'vim)
> +    (description "The build system for vim packages")
> +    (lower lower)))
> diff --git a/guix/build/vim-build-system.scm b/guix/build/vim-build-syste=
m.scm
> new file mode 100644
> index 000000000..70e8129df
> --- /dev/null
> +++ b/guix/build/vim-build-system.scm
> @@ -0,0 +1,93 @@
> +;;; GNU Guix --- Functional package management for GNU
> +;;; Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
> +;;;
> +;;; This file is part of GNU Guix.
> +;;;
> +;;; GNU Guix is free software; you can redistribute it and/or modify it
> +;;; under the terms of the GNU General Public License as published by
> +;;; the Free Software Foundation; either version 3 of the License, or (at
> +;;; your option) any later version.
> +;;;
> +;;; GNU Guix is distributed in the hope that it will be useful, but
> +;;; WITHOUT ANY WARRANTY; without even the implied warranty of
> +;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +;;; GNU General Public License for more details.
> +;;;
> +;;; You should have received a copy of the GNU General Public License
> +;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
> +
> +(define-module (guix build vim-build-system)
> +  #:use-module ((guix build gnu-build-system) #:prefix gnu:)
> +  #:use-module (guix build utils)
> +  #:use-module (srfi srfi-1)
> +  #:use-module (srfi srfi-11)
> +  #:use-module (srfi srfi-26)
> +  #:export (%standard-phases
> +            %default-exclude
> +            vim-build))
> +
> +;; Commentary:
> +;;
> +;; Builder-side code of the build procedure for vim packages.
> +;;
> +;; Code:
> +
> +;; These are the default inclusion/exclusion regexps for the install pha=
se.
> +(define %default-exclude '("^\\.github$" "^.*\\.md$" "LICENSE" "COPYING"
> +                           "^.*\\README.*$" "^\\.travis\\.yml$"
> +                           "^.*\\Makefile.*$"))
> +
> +(define gnu:unpack (assoc-ref gnu:%standard-phases 'unpack))
> +
> +(define (store-file->vim-source-file file)
> +  "Convert FILE, a store file name for an Vim source file, into a file
> +name that has been stripped of the hash and version number."
> +  (let ((suffix ".vim"))
> +    (let-values (((name version)
> +                  (package-name->name+version
> +                   (basename
> +                    (strip-store-file-name file) suffix))))
> +      (string-append name suffix))))
> +
> +(define* (unpack #:key source #:allow-other-keys)
> +  "Unpack SOURCE into the build directory.  SOURCE may be a compressed
> +archive, a directory or a '.vim' file."
> +  (if (string-suffix? ".vim" source)
> +      (begin
> +        (mkdir "source")
> +        (chdir "source")
> +        (copy-file source (store-file->vim-source-file source))
> +        #t)
> +      (gnu:unpack #:source source)))
> +
> +;; FIXME: Files like README.md and other, more unpredictable file names,
> +;; are currently being installed. Because there is no concept of a
> +;; standardized build-system in Vim extensions, we have to find a long-t=
erm
> +;; solution to exclusion of files that are not used at runtime.
> +(define* (install #:key outputs
> +                  (exclude %default-exclude)
> +                  #:allow-other-keys)
> +  "Install the package contents."
> +  (let* ((out (assoc-ref outputs "out"))
> +         (source (getcwd))
> +         (vimfiles (string-append out "/share/vim/vimfiles")))
> +    (for-each delete-file-recursively
> +              (find-files source "^\\.git$"))
> +    (for-each delete-file-recursively
> +              (find-files source "^\\.gitignore$"))
> +    (mkdir out)
> +    (copy-recursively "." vimfiles)
> +    #t))
> +
> +(define %standard-phases
> +  (modify-phases gnu:%standard-phases
> +    (replace 'unpack unpack)
> +    (delete 'configure)
> +    (delete 'check)
> +    (delete 'build)
> +    (replace 'install install)))
> +
> +(define* (vim-build #:key inputs (phases %standard-phases)
> +                      #:allow-other-keys #:rest args)
> +  "Build the given vim package, applying all of PHASES in order."
> +  (apply gnu:gnu-build #:inputs inputs #:phases phases args))
> --=20
> 2.16.1
>=20

> From 1b0a5ec5e59f65cfd6424a53e3bb24ad40586ed5 Mon Sep 17 00:00:00 2001
> From: ng0 <ng0@HIDDEN>
> Date: Sun, 2 Jul 2017 16:11:19 +0000
> Subject: [PATCH 2/4] gnu: vim-neocomplete: Use 'vim-build-system'.
>=20
> * gnu/packages/vim.scm (vim-neocomplete): Switch to 'vim-build-system'.
> ---
>  gnu/packages/vim.scm | 20 ++------------------
>  1 file changed, 2 insertions(+), 18 deletions(-)
>=20
> diff --git a/gnu/packages/vim.scm b/gnu/packages/vim.scm
> index abd25bc9d..7a843a0ab 100644
> --- a/gnu/packages/vim.scm
> +++ b/gnu/packages/vim.scm
> @@ -29,6 +29,7 @@
>    #:use-module (guix git-download)
>    #:use-module (guix build-system cmake)
>    #:use-module (guix build-system gnu)
> +  #:use-module (guix build-system vim)
>    #:use-module (gnu packages)
>    #:use-module (gnu packages acl)
>    #:use-module (gnu packages admin) ; For GNU hostname
> @@ -209,24 +210,7 @@ with the editor vim.")))
>         (sha256
>          (base32
>           "1307gbrdwam2akq9w2lpijc41740i4layk2qkd9sjkqxfch5lni2"))))
> -    (build-system gnu-build-system)
> -    (arguments
> -     `(#:tests? #f
> -       #:phases
> -       (modify-phases %standard-phases
> -         (delete 'configure)
> -         (delete 'build)
> -         (replace 'install
> -           (lambda* (#:key outputs #:allow-other-keys)
> -             (let* ((out (assoc-ref outputs "out"))
> -                    (vimfiles (string-append out "/share/vim/vimfiles"))
> -                    (autoload (string-append vimfiles "/autoload"))
> -                    (doc (string-append vimfiles "/doc"))
> -                    (plugin (string-append vimfiles "/plugin")))
> -               (copy-recursively "autoload" autoload)
> -               (copy-recursively "doc" doc)
> -               (copy-recursively "plugin" plugin)
> -               #t))))))
> +    (build-system vim-build-system)
>      (synopsis "Next generation completion framework for Vim")
>      (description
>       "@code{neocomplete}, an abbreviation of 'neo-completion with cache',
> --=20
> 2.16.1
>=20

> From cdbd15cf00e0bc1489437845f6c7f60fd517ab9a Mon Sep 17 00:00:00 2001
> From: ng0 <ng0@HIDDEN>
> Date: Wed, 7 Feb 2018 22:07:14 +0000
> Subject: [PATCH 3/4] gnu: vim-neosnippet-snippets: Use 'vim-build-system'.
>=20
> * gnu/packages/vim.scm (vim-neosnippet-snippets): Switch to 'vim-build-sy=
stem'.
> ---
>  gnu/packages/vim.scm | 17 ++---------------
>  1 file changed, 2 insertions(+), 15 deletions(-)
>=20
> diff --git a/gnu/packages/vim.scm b/gnu/packages/vim.scm
> index 7a843a0ab..13afbaeb4 100644
> --- a/gnu/packages/vim.scm
> +++ b/gnu/packages/vim.scm
> @@ -1,7 +1,7 @@
>  ;;; GNU Guix --- Functional package management for GNU
>  ;;; Copyright =C2=A9 2013 Cyril Roelandt <tipecaml@HIDDEN>
>  ;;; Copyright =C2=A9 2016, 2017, 2018 Efraim Flashner <efraim@HIDDEN=
o.il>
> -;;; Copyright =C2=A9 2016, 2017 ng0 <ng0@HIDDEN>
> +;;; Copyright =C2=A9 2016, 2017, 2018 ng0 <ng0@HIDDEN>
>  ;;; Copyright =C2=A9 2017 Ricardo Wurmus <rekado@HIDDEN>
>  ;;; Copyright =C2=A9 2017 Marius Bakke <mbakke@HIDDEN>
>  ;;; Copyright =C2=A9 2018 Tobias Geerinckx-Rice <me@HIDDEN>
> @@ -238,20 +238,7 @@ features than Vim's built-in completion.")
>           (sha256
>            (base32
>             "151wpvbj6jb9jdkbhj3b77f5sq7y328spvwfbqyj1y32rg4ifmc6"))))
> -      (build-system gnu-build-system)
> -      (arguments
> -       `(#:tests? #f
> -         #:phases
> -         (modify-phases %standard-phases
> -           (delete 'configure)
> -           (delete 'build)
> -           (replace 'install
> -             (lambda* (#:key outputs #:allow-other-keys)
> -               (let* ((out (assoc-ref outputs "out"))
> -                      (vimfiles (string-append out "/share/vim/vimfiles"=
)))
> -                 (copy-recursively "neosnippets"
> -                                   (string-append vimfiles "/neosnippets=
"))
> -               #t))))))
> +      (build-system vim-build-system)
>      (synopsis "Snippets for neosnippet")
>      (description
>       "@code{neosnippet-snippets} provides standard snippets for the Vim =
plugin
> --=20
> 2.16.1
>=20

> From 09cc9c735da27d0adb1ef141bbd2b7d37e1d6754 Mon Sep 17 00:00:00 2001
> From: ng0 <ng0@HIDDEN>
> Date: Wed, 7 Feb 2018 22:14:58 +0000
> Subject: [PATCH 4/4] gnu: vim-neosnippet: Use 'vim-build-system'.
>=20
> * gnu/packages/vim.scm (vim-neosnippet): Switch to 'vim-build-system'.
> ---
>  gnu/packages/vim.scm | 29 +----------------------------
>  1 file changed, 1 insertion(+), 28 deletions(-)
>=20
> diff --git a/gnu/packages/vim.scm b/gnu/packages/vim.scm
> index 13afbaeb4..99361fa5d 100644
> --- a/gnu/packages/vim.scm
> +++ b/gnu/packages/vim.scm
> @@ -264,34 +264,7 @@ you can fill in on the fly.")
>         (sha256
>          (base32
>           "0k80syscmpnj38ks1fq02ds59g0r4jlg9ll7z4qc048mgi35alw5"))))
> -    (build-system gnu-build-system)
> -    (arguments
> -     `(#:tests? #f
> -       #:phases
> -       (modify-phases %standard-phases
> -         (delete 'configure)
> -         (delete 'build)
> -         (replace 'install
> -           (lambda* (#:key outputs #:allow-other-keys)
> -             (let* ((out (assoc-ref outputs "out"))
> -                    (vimfiles (string-append out "/share/vim/vimfiles"))
> -                    (autoload (string-append vimfiles "/autoload"))
> -                    (doc (string-append vimfiles "/doc"))
> -                    (ftdetect (string-append vimfiles "/ftdetect"))
> -                    (ftplugin (string-append vimfiles "/ftplugin"))
> -                    (indent (string-append vimfiles "/indent"))
> -                    (plugin (string-append vimfiles "/plugin"))
> -                    (rplugin (string-append vimfiles "/rplugin"))
> -                    (syntax (string-append vimfiles "/syntax")))
> -               (copy-recursively "autoload" autoload)
> -               (copy-recursively "doc" doc)
> -               (copy-recursively "ftdetect" ftdetect)
> -               (copy-recursively "ftplugin" ftplugin)
> -               (copy-recursively "indent" indent)
> -               (copy-recursively "plugin" plugin)
> -               (copy-recursively "rplugin" rplugin)
> -               (copy-recursively "syntax" syntax)
> -               #t))))))
> +    (build-system vim-build-system)
>      (synopsis "Snippet support for Vim")
>      (description
>       "@code{neosnippet}, is a plugin for Vim which adds snippet support =
to Vim.
> --=20
> 2.16.1
>=20

> --=20
> ng0 :: https://ea.n0.is
> A88C8ADD129828D7EAC02E52E22F9BBFEE348588 :: https://ea.n0.is/keys/




--=20
A88C8ADD129828D7EAC02E52E22F9BBFEE348588
https://n0.is
--bby7qmk6raz3dxfv
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAABCgAdFiEEqIyK3RKYKNfqwC5S4i+bv+40hYgFAlqWbjkACgkQ4i+bv+40
hYiHFxAAqi0H/0Nouq+xpaokYIoP6ExTY25ZlcT1SN0MTCuvb5ituav2+suS/Aq8
iYqXgUdKwm/XmZf7xupEjD/3lMR+0Vq+6+ESe0hiQuuswTT1GHs1JFpYUN8h5zkv
7l6Yw0yo6T2BTP83+8ZguzFxIzEG1OwDh04P1cn8kE4jc0J0n3RsxlPP0iDLdWpt
jQfd1LSkYMiXl9KHACJyU6p7ftpgSnv98Z1MRq4KcVa1Uco0n9Ebx4DVwH8h5QRU
WFg+sChRZ6FJ+jOnrPG6MG+otUxosiyvzX3Fjtu6/vT1Sg24AIuY4igCCNQuNUip
zSJ34mf5tXKZXp7DiSVv2cBVHeLf4fv8yUUEzubxxp9BQ8ZfVNBW2x4yAnZRXFu0
lvq3CTiTtK23P8lXZ5jatyhZ3dZT0k+OMbkHR1co/nPz1LctLcVMiECIVvUqvyYu
zIPJec13EElgrzrpFiI/WtTLUTOvI8DVD0S+nvNXWEZPTT5sLjhhTcWELSkwW4Vp
97oOc1Q9UwBf0hLRsTgHXc4wppT9cw+SU3Cej5IkelbCPHBAcfaDKuutsHRef6oE
Kq8kI11C33uK7xkBesbe97bVBKXMx5VgGzTmtBhmlP7FunulV1dXu1JVET1zg5bq
LDSUApLKtc+7MBO3V8FcJVus9crloN2zKQToOc5AiiS/VOtKoDg=
=wUbP
-----END PGP SIGNATURE-----

--bby7qmk6raz3dxfv--




Information forwarded to guix-patches@HIDDEN:
bug#30385; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 7 Feb 2018 22:33:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Feb 07 17:33:19 2018
Received: from localhost ([127.0.0.1]:33560 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ejYHC-0005ow-PM
	for submit <at> debbugs.gnu.org; Wed, 07 Feb 2018 17:33:19 -0500
Received: from eggs.gnu.org ([208.118.235.92]:41516)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ng0@HIDDEN>) id 1ejYF2-0005lN-1m
 for submit <at> debbugs.gnu.org; Wed, 07 Feb 2018 17:31:04 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ng0@HIDDEN>) id 1ejYEu-0004xu-Fe
 for submit <at> debbugs.gnu.org; Wed, 07 Feb 2018 17:30:54 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:50870)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <ng0@HIDDEN>) id 1ejYEu-0004xq-Ae
 for submit <at> debbugs.gnu.org; Wed, 07 Feb 2018 17:30:52 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:60720)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <ng0@HIDDEN>) id 1ejYEr-0000pG-Gy
 for guix-patches@HIDDEN; Wed, 07 Feb 2018 17:30:52 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ng0@HIDDEN>) id 1ejYEo-0004vt-8A
 for guix-patches@HIDDEN; Wed, 07 Feb 2018 17:30:49 -0500
Received: from aibo.runbox.com ([91.220.196.211]:50438)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <ng0@HIDDEN>) id 1ejYEn-0004vM-Mn
 for guix-patches@HIDDEN; Wed, 07 Feb 2018 17:30:46 -0500
Received: from [10.9.9.212] (helo=mailfront12.runbox.com)
 by mailtransmit03.runbox with esmtp (Exim 4.86_2)
 (envelope-from <ng0@HIDDEN>) id 1ejYEl-0000aC-E9
 for guix-patches@HIDDEN; Wed, 07 Feb 2018 23:30:43 +0100
Received: from dslb-088-078-082-190.088.078.pools.vodafone-ip.de
 ([88.78.82.190] helo=localhost)
 by mailfront12.runbox.com with esmtpsa (uid:892961 )
 (TLS1.2:RSA_AES_256_CBC_SHA1:256) (Exim 4.82) id 1ejYET-0001iO-MW
 for guix-patches@HIDDEN; Wed, 07 Feb 2018 23:30:26 +0100
From: ng0@HIDDEN
To: guix-patches@HIDDEN
Subject: Add vim-build-system
Date: Wed, 07 Feb 2018 22:30:30 +0000
Message-ID: <87a7wkv3eh.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="==-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Wed, 07 Feb 2018 17:33:13 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

--==-=-=
Content-Type: multipart/mixed; boundary="=-=-="

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

This adds a first version of a functional vim-build-system.

As explained today on IRC, and as you can guess by reading
gnu/packages/vim.scm Vim has a concept of folders and files in
standard places, but Makefiles and similar tools are an
exception. Usually you have to copy them somewhere (or use
external Vim package managers that pull the files for yoz and set
the "run time path" (rtp) for you).

There's also (to my best knowledge, keep in mind I've last read
into Vim when I did the last commits in the Vim module) no ENV
VAR or anything we could export, you have to manually set

  set rtp+=3D~/.guix-profile/share/vim/vimfiles/

in your $home/.vimrc

The build system comes with a FIXME note, but it works. I'm in
the middle of tests and exams, so this is the best I can correct
from my earlier attempt in '17 on this. What I can apply are
changes and adjustments to what I submit now.

4 Patches attached, 3 of them are for proof of work.


--=-=-=
Content-Type: text/x-patch; charset=utf-8
Content-Disposition: inline;
 filename=0001-build-system-Add-vim-build-system.patch
Content-Transfer-Encoding: quoted-printable

From=20617fc10671c18c35c0e3fcd6bc0c9d06a96a4ebf Mon Sep 17 00:00:00 2001
From: ng0 <ng0@HIDDEN>
Date: Sun, 2 Jul 2017 16:07:48 +0000
Subject: [PATCH 1/4] build-system: Add 'vim-build-system'.

* Makefile.am (MODULES): Add 'guix/build-system/vim.scm' and
'guix/build/vim-build-system.scm'.
* guix/build-system/vim.scm: New file.
* guix/build/vim-build-system.scm: New file.
=2D--
 Makefile.am                     |   4 +-
 guix/build-system/vim.scm       | 129 ++++++++++++++++++++++++++++++++++++=
++++
 guix/build/vim-build-system.scm |  93 +++++++++++++++++++++++++++++
 3 files changed, 225 insertions(+), 1 deletion(-)
 create mode 100644 guix/build-system/vim.scm
 create mode 100644 guix/build/vim-build-system.scm

diff --git a/Makefile.am b/Makefile.am
index eb5d38231..72ad184ef 100644
=2D-- a/Makefile.am
+++ b/Makefile.am
@@ -9,7 +9,7 @@
 # Copyright =C2=A9 2017 Ricardo Wurmus <rekado@HIDDEN>
 # Copyright =C2=A9 2017 Jan Nieuwenhuizen <janneke@HIDDEN>
 # Copyright =C2=A9 2017 Arun Isaac <arunisaac@HIDDEN>
=2D# Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
+# Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
 #
 # This file is part of GNU Guix.
 #
@@ -106,6 +106,7 @@ MODULES =3D					\
   guix/build-system/perl.scm			\
   guix/build-system/python.scm			\
   guix/build-system/ocaml.scm			\
+  guix/build-system/vim.scm                     \
   guix/build-system/waf.scm			\
   guix/build-system/r.scm			\
   guix/build-system/ruby.scm			\
@@ -134,6 +135,7 @@ MODULES =3D					\
   guix/build/font-build-system.scm		\
   guix/build/go-build-system.scm		\
   guix/build/asdf-build-system.scm		\
+  guix/build/vim-build-system.scm               \
   guix/build/git.scm				\
   guix/build/hg.scm				\
   guix/build/glib-or-gtk-build-system.scm	\
diff --git a/guix/build-system/vim.scm b/guix/build-system/vim.scm
new file mode 100644
index 000000000..67657c7d8
=2D-- /dev/null
+++ b/guix/build-system/vim.scm
@@ -0,0 +1,129 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix build-system vim)
+  #:use-module (guix utils)
+  #:use-module (guix packages)
+  #:use-module (guix derivations)
+  #:use-module (guix store)
+  #:use-module (guix search-paths)
+  #:use-module (guix build-system)
+  #:use-module (guix build-system gnu)
+  #:use-module (ice-9 match)
+  #:export (%vim-build-system-modules
+            vim-build
+            vim-build-system))
+
+;; Commentary:
+;;
+;; Standard build procedure for vim packages.  This is
+;; implemented as an extension of 'gnu-build-system'.
+;;
+;; Code:
+
+(define %vim-build-system-modules
+  ;; Build-side modules imported by default.
+  `((guix build vim-build-system)
+    ,@%gnu-build-system-modules))
+
+(define* (lower name
+                #:key source inputs native-inputs outputs system target
+                #:allow-other-keys
+                #:rest arguments)
+  "Return a bag for NAME."
+  (define private-keywords
+    '(#:target #:inputs #:native-inputs))
+
+  (bag
+    (name name)
+    (system system)
+    (host-inputs `(,@(if source
+                         `(("source" ,source))
+                         '())
+                   ,@inputs
+                   ,(list "tar" (module-ref (resolve-interface '(gnu packa=
ges base)) 'tar))
+                   ,@(let ((compression (resolve-interface '(gnu packages =
compression))))
+                       (map (match-lambda
+                              ((name package)
+                               (list name (module-ref compression package)=
)))
+                            `(("gzip" gzip)
+                              ("bzip2" bzip2)
+                              ("unzip" unzip)
+                              ("xz" xz))))))
+    (build-inputs native-inputs)
+    (outputs outputs)
+    (build vim-build)
+    (arguments (strip-keyword-arguments private-keywords arguments))))
+
+(define* (vim-build store name inputs
+                     #:key source
+                     (tests? #t)
+                     (test-target "test")
+                     (configure-flags ''())
+                     (phases '(@ (guix build vim-build-system)
+                                 %standard-phases))
+                     (outputs '("out"))
+                     (search-paths '())
+                     (system (%current-system))
+                     (guile #f)
+                     (imported-modules %vim-build-system-modules)
+                     (modules '((guix build vim-build-system)
+                                (guix build utils))))
+  "Build SOURCE with INPUTS."
+  (define builder
+    `(begin
+       (use-modules ,@modules)
+       (vim-build #:name ,name
+                   #:source ,(match (assoc-ref inputs "source")
+                               (((? derivation? source))
+                                (derivation->output-path source))
+                               ((source)
+                                source)
+                               (source
+                                source))
+                   #:configure-flags ,configure-flags
+                   #:system ,system
+                   #:test-target ,test-target
+                   #:tests? ,tests?
+                   #:phases ,phases
+                   #:outputs %outputs
+                   #:search-paths ',(map search-path-specification->sexp
+                                         search-paths)
+                   #:inputs %build-inputs)))
+
+  (define guile-for-build
+    (match guile
+      ((? package?)
+       (package-derivation store guile system #:graft? #f))
+      (#f                                         ; the default
+       (let* ((distro (resolve-interface '(gnu packages commencement)))
+              (guile  (module-ref distro 'guile-final)))
+         (package-derivation store guile system #:graft? #f)))))
+
+  (build-expression->derivation store name builder
+                                #:inputs inputs
+                                #:system system
+                                #:modules imported-modules
+                                #:outputs outputs
+                                #:guile-for-build guile-for-build))
+
+(define vim-build-system
+  (build-system
+    (name 'vim)
+    (description "The build system for vim packages")
+    (lower lower)))
diff --git a/guix/build/vim-build-system.scm b/guix/build/vim-build-system.=
scm
new file mode 100644
index 000000000..70e8129df
=2D-- /dev/null
+++ b/guix/build/vim-build-system.scm
@@ -0,0 +1,93 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright =C2=A9 2018 ng0 <ng0@HIDDEN>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (guix build vim-build-system)
+  #:use-module ((guix build gnu-build-system) #:prefix gnu:)
+  #:use-module (guix build utils)
+  #:use-module (srfi srfi-1)
+  #:use-module (srfi srfi-11)
+  #:use-module (srfi srfi-26)
+  #:export (%standard-phases
+            %default-exclude
+            vim-build))
+
+;; Commentary:
+;;
+;; Builder-side code of the build procedure for vim packages.
+;;
+;; Code:
+
+;; These are the default inclusion/exclusion regexps for the install phase.
+(define %default-exclude '("^\\.github$" "^.*\\.md$" "LICENSE" "COPYING"
+                           "^.*\\README.*$" "^\\.travis\\.yml$"
+                           "^.*\\Makefile.*$"))
+
+(define gnu:unpack (assoc-ref gnu:%standard-phases 'unpack))
+
+(define (store-file->vim-source-file file)
+  "Convert FILE, a store file name for an Vim source file, into a file
+name that has been stripped of the hash and version number."
+  (let ((suffix ".vim"))
+    (let-values (((name version)
+                  (package-name->name+version
+                   (basename
+                    (strip-store-file-name file) suffix))))
+      (string-append name suffix))))
+
+(define* (unpack #:key source #:allow-other-keys)
+  "Unpack SOURCE into the build directory.  SOURCE may be a compressed
+archive, a directory or a '.vim' file."
+  (if (string-suffix? ".vim" source)
+      (begin
+        (mkdir "source")
+        (chdir "source")
+        (copy-file source (store-file->vim-source-file source))
+        #t)
+      (gnu:unpack #:source source)))
+
+;; FIXME: Files like README.md and other, more unpredictable file names,
+;; are currently being installed. Because there is no concept of a
+;; standardized build-system in Vim extensions, we have to find a long-term
+;; solution to exclusion of files that are not used at runtime.
+(define* (install #:key outputs
+                  (exclude %default-exclude)
+                  #:allow-other-keys)
+  "Install the package contents."
+  (let* ((out (assoc-ref outputs "out"))
+         (source (getcwd))
+         (vimfiles (string-append out "/share/vim/vimfiles")))
+    (for-each delete-file-recursively
+              (find-files source "^\\.git$"))
+    (for-each delete-file-recursively
+              (find-files source "^\\.gitignore$"))
+    (mkdir out)
+    (copy-recursively "." vimfiles)
+    #t))
+
+(define %standard-phases
+  (modify-phases gnu:%standard-phases
+    (replace 'unpack unpack)
+    (delete 'configure)
+    (delete 'check)
+    (delete 'build)
+    (replace 'install install)))
+
+(define* (vim-build #:key inputs (phases %standard-phases)
+                      #:allow-other-keys #:rest args)
+  "Build the given vim package, applying all of PHASES in order."
+  (apply gnu:gnu-build #:inputs inputs #:phases phases args))
=2D-=20
2.16.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline;
 filename=0002-gnu-vim-neocomplete-Use-vim-build-system.patch
Content-Transfer-Encoding: quoted-printable

From=201b0a5ec5e59f65cfd6424a53e3bb24ad40586ed5 Mon Sep 17 00:00:00 2001
From: ng0 <ng0@HIDDEN>
Date: Sun, 2 Jul 2017 16:11:19 +0000
Subject: [PATCH 2/4] gnu: vim-neocomplete: Use 'vim-build-system'.

* gnu/packages/vim.scm (vim-neocomplete): Switch to 'vim-build-system'.
=2D--
 gnu/packages/vim.scm | 20 ++------------------
 1 file changed, 2 insertions(+), 18 deletions(-)

diff --git a/gnu/packages/vim.scm b/gnu/packages/vim.scm
index abd25bc9d..7a843a0ab 100644
=2D-- a/gnu/packages/vim.scm
+++ b/gnu/packages/vim.scm
@@ -29,6 +29,7 @@
   #:use-module (guix git-download)
   #:use-module (guix build-system cmake)
   #:use-module (guix build-system gnu)
+  #:use-module (guix build-system vim)
   #:use-module (gnu packages)
   #:use-module (gnu packages acl)
   #:use-module (gnu packages admin) ; For GNU hostname
@@ -209,24 +210,7 @@ with the editor vim.")))
        (sha256
         (base32
          "1307gbrdwam2akq9w2lpijc41740i4layk2qkd9sjkqxfch5lni2"))))
=2D    (build-system gnu-build-system)
=2D    (arguments
=2D     `(#:tests? #f
=2D       #:phases
=2D       (modify-phases %standard-phases
=2D         (delete 'configure)
=2D         (delete 'build)
=2D         (replace 'install
=2D           (lambda* (#:key outputs #:allow-other-keys)
=2D             (let* ((out (assoc-ref outputs "out"))
=2D                    (vimfiles (string-append out "/share/vim/vimfiles"))
=2D                    (autoload (string-append vimfiles "/autoload"))
=2D                    (doc (string-append vimfiles "/doc"))
=2D                    (plugin (string-append vimfiles "/plugin")))
=2D               (copy-recursively "autoload" autoload)
=2D               (copy-recursively "doc" doc)
=2D               (copy-recursively "plugin" plugin)
=2D               #t))))))
+    (build-system vim-build-system)
     (synopsis "Next generation completion framework for Vim")
     (description
      "@code{neocomplete}, an abbreviation of 'neo-completion with cache',
=2D-=20
2.16.1


--=-=-=
Content-Type: text/x-patch; charset=utf-8
Content-Disposition: inline;
 filename=0003-gnu-vim-neosnippet-snippets-Use-vim-build-system.patch
Content-Transfer-Encoding: quoted-printable

From=20cdbd15cf00e0bc1489437845f6c7f60fd517ab9a Mon Sep 17 00:00:00 2001
From: ng0 <ng0@HIDDEN>
Date: Wed, 7 Feb 2018 22:07:14 +0000
Subject: [PATCH 3/4] gnu: vim-neosnippet-snippets: Use 'vim-build-system'.

* gnu/packages/vim.scm (vim-neosnippet-snippets): Switch to 'vim-build-syst=
em'.
=2D--
 gnu/packages/vim.scm | 17 ++---------------
 1 file changed, 2 insertions(+), 15 deletions(-)

diff --git a/gnu/packages/vim.scm b/gnu/packages/vim.scm
index 7a843a0ab..13afbaeb4 100644
=2D-- a/gnu/packages/vim.scm
+++ b/gnu/packages/vim.scm
@@ -1,7 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright =C2=A9 2013 Cyril Roelandt <tipecaml@HIDDEN>
 ;;; Copyright =C2=A9 2016, 2017, 2018 Efraim Flashner <efraim@HIDDEN=
il>
=2D;;; Copyright =C2=A9 2016, 2017 ng0 <ng0@HIDDEN>
+;;; Copyright =C2=A9 2016, 2017, 2018 ng0 <ng0@HIDDEN>
 ;;; Copyright =C2=A9 2017 Ricardo Wurmus <rekado@HIDDEN>
 ;;; Copyright =C2=A9 2017 Marius Bakke <mbakke@HIDDEN>
 ;;; Copyright =C2=A9 2018 Tobias Geerinckx-Rice <me@HIDDEN>
@@ -238,20 +238,7 @@ features than Vim's built-in completion.")
          (sha256
           (base32
            "151wpvbj6jb9jdkbhj3b77f5sq7y328spvwfbqyj1y32rg4ifmc6"))))
=2D      (build-system gnu-build-system)
=2D      (arguments
=2D       `(#:tests? #f
=2D         #:phases
=2D         (modify-phases %standard-phases
=2D           (delete 'configure)
=2D           (delete 'build)
=2D           (replace 'install
=2D             (lambda* (#:key outputs #:allow-other-keys)
=2D               (let* ((out (assoc-ref outputs "out"))
=2D                      (vimfiles (string-append out "/share/vim/vimfiles"=
)))
=2D                 (copy-recursively "neosnippets"
=2D                                   (string-append vimfiles "/neosnippets=
"))
=2D               #t))))))
+      (build-system vim-build-system)
     (synopsis "Snippets for neosnippet")
     (description
      "@code{neosnippet-snippets} provides standard snippets for the Vim pl=
ugin
=2D-=20
2.16.1


--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline;
 filename=0004-gnu-vim-neosnippet-Use-vim-build-system.patch
Content-Transfer-Encoding: quoted-printable

From=2009cc9c735da27d0adb1ef141bbd2b7d37e1d6754 Mon Sep 17 00:00:00 2001
From: ng0 <ng0@HIDDEN>
Date: Wed, 7 Feb 2018 22:14:58 +0000
Subject: [PATCH 4/4] gnu: vim-neosnippet: Use 'vim-build-system'.

* gnu/packages/vim.scm (vim-neosnippet): Switch to 'vim-build-system'.
=2D--
 gnu/packages/vim.scm | 29 +----------------------------
 1 file changed, 1 insertion(+), 28 deletions(-)

diff --git a/gnu/packages/vim.scm b/gnu/packages/vim.scm
index 13afbaeb4..99361fa5d 100644
=2D-- a/gnu/packages/vim.scm
+++ b/gnu/packages/vim.scm
@@ -264,34 +264,7 @@ you can fill in on the fly.")
        (sha256
         (base32
          "0k80syscmpnj38ks1fq02ds59g0r4jlg9ll7z4qc048mgi35alw5"))))
=2D    (build-system gnu-build-system)
=2D    (arguments
=2D     `(#:tests? #f
=2D       #:phases
=2D       (modify-phases %standard-phases
=2D         (delete 'configure)
=2D         (delete 'build)
=2D         (replace 'install
=2D           (lambda* (#:key outputs #:allow-other-keys)
=2D             (let* ((out (assoc-ref outputs "out"))
=2D                    (vimfiles (string-append out "/share/vim/vimfiles"))
=2D                    (autoload (string-append vimfiles "/autoload"))
=2D                    (doc (string-append vimfiles "/doc"))
=2D                    (ftdetect (string-append vimfiles "/ftdetect"))
=2D                    (ftplugin (string-append vimfiles "/ftplugin"))
=2D                    (indent (string-append vimfiles "/indent"))
=2D                    (plugin (string-append vimfiles "/plugin"))
=2D                    (rplugin (string-append vimfiles "/rplugin"))
=2D                    (syntax (string-append vimfiles "/syntax")))
=2D               (copy-recursively "autoload" autoload)
=2D               (copy-recursively "doc" doc)
=2D               (copy-recursively "ftdetect" ftdetect)
=2D               (copy-recursively "ftplugin" ftplugin)
=2D               (copy-recursively "indent" indent)
=2D               (copy-recursively "plugin" plugin)
=2D               (copy-recursively "rplugin" rplugin)
=2D               (copy-recursively "syntax" syntax)
=2D               #t))))))
+    (build-system vim-build-system)
     (synopsis "Snippet support for Vim")
     (description
      "@code{neosnippet}, is a plugin for Vim which adds snippet support to=
 Vim.
=2D-=20
2.16.1


--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

=2D-=20
ng0 :: https://ea.n0.is
A88C8ADD129828D7EAC02E52E22F9BBFEE348588 :: https://ea.n0.is/keys/

--=-=-=--

--==-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCgAdFiEEqIyK3RKYKNfqwC5S4i+bv+40hYgFAlp7fgYACgkQ4i+bv+40
hYjf0RAAhUe72DTRU8UhnbKsKqqC2T6bBgB6OrfZe7srKRJnOlWxrUA3WyVoZ0SB
f2sRlknTQz6ESQhPwbDqqqaR4KLd7hWuAtImWrnO/Y8H+W2ydCMqOCgN85SZ1Dgs
fAFAee0LoI1MUMADEV0u9W/YNYv0GlEAVw9fuMbxq2pAZJjpgGfkDGDFG4iosxDP
vWZkVNPBWuLb3vTdsyl1pO3UeoKo2n/9X0AmJezIVg4eqmtCZmieoMfYERVNerpD
V3pqZTJWksiUwIxVyJL/dX/1a56PnsbGEl9Sypgg3/efuH4Itfpts1mttCkrsSB+
AbdSY8KPIwwJsplYtmdJuJjfCEV+ZxoS692ARYpPcjR2KNCLu9Mwhg2EzoIiVFFW
mCYziYIIE+BiLiMDVmuFtZH4/IhFb4f4b6w6o3a6V9qqihbV81MrYPAYChIFEBHh
2EiCzQ40Y17Oj4XaHuX0YfhocSJsiqi3UqXKWZi6ZDhSKYmH6+niwLTEOuJwNof/
4bsgFsWy5tscDCZB/wHhfxHfDVmjqM5DrmjK7EFKeoPRo9vZukaKfOySY9GHhvdJ
g4GSW1xmdtIsCWuw0XUavegTwZ+1hvvwgzXzX0hmTp3y4CgxCDHk7todI/SeoS50
KjlFnepyQt/I4RYwIsX5km7TJehcIV7db0QS7QfA1VpTC41qyzE=
=4NjI
-----END PGP SIGNATURE-----
--==-=-=--




Acknowledgement sent to ng0@HIDDEN:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#30385; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 2 Jul 2018 21:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.